unit U_BSPrtDyeStkSel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit,
  cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore, dxSkinsDefaultPainters,
  cxNavigator, dxDateRanges, dxBarBuiltInMenu, U_BaseHelp, System.ImageList,
  Vcl.ImgList, dxScrollbarAnnotations;

type
  TfrmBSPrtDyeStkSel = class(TfrmBaseHelp)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    CDS_Main: TClientDataSet;
    CDS_HZ: TClientDataSet;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ToolButton1: TToolButton;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column17: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label2: TLabel;
    P_name: TEdit;
    FromCoName: TEdit;
    P_Spec: TEdit;
    BatchNo: TEdit;
    v1Column6: TcxGridDBColumn;
    ToolButton2: TToolButton;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure MPRTCodeNameChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure SXBatchNOChange(Sender: TObject);
    procedure FromCoNameChange(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Tv1CellDblClick(Sender: TcxCustomGridTableView; ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
    procedure ToolButton2Click(Sender: TObject);
  private
    procedure InitGrid();
    { Private declarations }
  public
    FstkName: string;
    { Public declarations }
  end;

var
  frmBSPrtDyeStkSel: TfrmBSPrtDyeStkSel;

implementation

uses
  U_DataLink, U_RTFun;

{$R *.dfm}

procedure TfrmBSPrtDyeStkSel.FormDestroy(Sender: TObject);
begin
  inherited;
  frmBSPrtDyeStkSel := nil;
end;

procedure TfrmBSPrtDyeStkSel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmBSPrtDyeStkSel.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;

      SQL.Add('SELECT ');
      SQL.Add('  A.P_Code, ');
      SQL.Add('  A.P_Spec, ');
      SQL.Add('  A.BatchNo, ');
//      SQL.Add('  A.FromCoName, ');
       SQL.Add('  A.QtyUnit, ');

      SQL.Add('  SUM(IOQtyFlag*qty) as StkQty, ');
      SQL.Add('  MAX(A.IOTime) as IOTime, ');
      SQL.Add('  MAX(A.P_Name) as P_Name ');

      SQL.Add('FROM BS_Product_IO A ');
      SQL.Add('WHERE  ');
      SQL.Add(' ISNULL(A.stkName,'''')=''' + Trim(FstkName) + '''');
      SQL.Add('GROUP BY A.P_Code, A.P_Spec, A.BatchNo, QtyUnit');
      SQL.Add(' having sum(IOQtyFlag*qty)>0   ');
//      SQL.Add('SELECT A.* ');
//
//      SQL.Add('FROM BS_Product_IO A ');
//      SQL.Add('WHERE A.IOFlag=''入库'' AND ISNULL(A.StkQty,0)>0 ');
//      SQL.Add('AND ISNULL(A.stkName,'''')=''' + Trim(FstkName) + '''');
//      ShowMessage(sql.Text);
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmBSPrtDyeStkSel.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmBSPrtDyeStkSel.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmBSPrtDyeStkSel.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmBSPrtDyeStkSel.FormShow(Sender: TObject);
begin
  inherited;
  ReadCxGrid(trim(self.Caption), Tv1, '机物料仓库');
  InitGrid();
end;

procedure TfrmBSPrtDyeStkSel.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmBSPrtDyeStkSel.MPRTCodeNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmBSPrtDyeStkSel.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmBSPrtDyeStkSel.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmBSPrtDyeStkSel.SXBatchNOChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmBSPrtDyeStkSel.FromCoNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmBSPrtDyeStkSel.ToolButton1Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ModalResult := 1;
end;

procedure TfrmBSPrtDyeStkSel.ToolButton2Click(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption), Tv1, '机物料仓库');
end;

procedure TfrmBSPrtDyeStkSel.Tv1CellDblClick(Sender: TcxCustomGridTableView; ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton; AShift: TShiftState; var AHandled: Boolean);
begin
  ModalResult := 1;
end;

end.

